<script setup lang="ts">
import { Check, PlayCircle } from 'slippers-ui/icons';
import PlayButton from '~/assets/icons/play-button.vue';

type VideoSpotlightProps = {
  title: string;
  benefits: { text: string }[];
  cta: string;
  button: {
    text: string;
    config: {
      url: string;
      dataGaName: string;
      dataGaLocation: string;
    };
  };
  video: {
    buttonText: string;
    config: {
      dataGaName: string;
      dataGaLocation: string;
      src: string;
      thumbnail: string;
    };
  };
};

defineProps<VideoSpotlightProps>();

const modalOpen = ref(false);
const openModal = () => {
  modalOpen.value = true;
};
const closeModal = () => {
  modalOpen.value = false;
};
</script>

<template>
  <section id="video-spotlight-section">
    <SlpContainer>
      <SlpTypography class="title word-break" tag="h2" variant="heading2-bold">
        <span v-html="title" />
      </SlpTypography>
      <SlpRow>
        <SlpColumn :cols="5">
          <ul>
            <li v-for="benefit in benefits" :key="benefit.text" class="benefit">
              <SlpIcon :icon="Check" size="md" color="accent-400" class="slp-mr-16" />
              <SlpTypography tag="span" variant="heading5-bold">{{ benefit.text }}</SlpTypography>
            </li>
          </ul>
          <div class="cta word-break" v-html="$md.render(cta)" />
          <SlpButton
            class="button"
            variant="primary"
            :href="button.config.url"
            :data-ga-name="button.config.dataGaName"
            :data-ga-location="button.config.dataGaLocation"
          >
            {{ button.text }}
          </SlpButton>
        </SlpColumn>
        <SlpColumn>
          <div class="video-thumbnail" @click="openModal">
            <NuxtImg :src="video.config.thumbnail" alt="platform video" />
            <SlpButton
              variant="secondary"
              :data-ga-name="video.config.dataGaName"
              :data-ga-location="video.config.dataGaLocation"
              class="video-spotlight-button"
            >
              <SlpIcon :icon="PlayCircle" size="sm" class="slp-mr-16" color="accent-400" />
              {{ video.buttonText }}
            </SlpButton>
          </div>
          <Teleport to="body">
            <CommonVideoModal :visible="modalOpen" @close="closeModal">
              <template #body>
                <CommonVideo :video-src="video.config.src" class="video" :thumbnail-src="video.config.thumbnail">
                  <template #customPlayButton>
                    <div class="vimeo-play-button">
                      <PlayButton />
                    </div>
                  </template>
                </CommonVideo>
              </template>
            </CommonVideoModal>
          </Teleport>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.button,
.slp-row {
  @media (max-width: $breakpoint-sm) {
    width: 100%;
  }
}

.button {
  @media (max-width: $breakpoint-sm) {
    margin-bottom: $spacing-64;
    justify-content: center;
  }
}

#video-spotlight-section {
  padding: 160px 0px 120px 0px;
}

.video-thumbnail {
  position: relative;
  height: 100%;
  border-radius: 14px;
  overflow: hidden;
  img {
    object-fit: cover;
    width: 100%;
    height: 100%;
  }
}

.video-spotlight-button {
  position: absolute;
  left: 50%;
  top: 50%;
  transform: translate3d(-50%, -50%, 0);
  width: 100%;
  max-width: 170px;
  border-radius: 48px;
}

.title {
  margin-bottom: $spacing-48;
}

.cta {
  margin-top: $spacing-32;
}

.word-break {
  word-break: break-word;
  overflow-wrap: break-word;
  white-space: pre-wrap;

  :deep(strong) {
    font-size: 18px;
  }
}

.benefit:not(:first-child) {
  margin-top: $spacing-16;
}

.vimeo-play-button {
  position: absolute;
  left: 45%;
  top: 43%;
  background: #ffffff;
  transition: 0.15s;
  padding: 8px 24px;
  color: #171321;
  border-radius: 4px;
  width: 88px;
  height: 56px;
  display: flex;
  justify-content: center;
  align-items: center;
  @media (max-width: $breakpoint-sm) {
    left: 40%;
    top: 38%;
    width: 70px;
    height: 46px;
  }
}

.video:hover {
  .vimeo-play-button {
    background: #e8e7eb;
  }
}
</style>
